<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>morphorobotx: Robot.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">morphorobotx
   </div>
   <div id="projectbrief">morphorobotxsharedlibrary</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1.2 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Namespaces</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(9)"><span class="SelectionMark">&#160;</span>Macros</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Robot.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="Robot_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/* </span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * File:   Robot.hpp</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> * Author: cfmadmin</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> * Created on February 7, 2013, 9:42 PM</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef ROBOT_HPP</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor"></span><span class="preprocessor">#define ROBOT_HPP</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor"></span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;QString&quot;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="ForceMeasurement_8hpp.html">ForceMeasurement.hpp</a>&quot;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="ActuatorAxis_8hpp.html">ActuatorAxis.hpp</a>&quot;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//NOTE: this is added only to support doxygen in recognizing vectors as links between classes</span></div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="code" href="namespacestd.html">   17</a></span>&#160;<span class="keyword">namespace </span>std {</div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="code" href="classstd_1_1vector.html#aa4413180f775cf542ab040103fb94438">   18</a></span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt; <span class="keyword">class </span><a class="code" href="classstd_1_1vector.html">vector</a> { <span class="keyword">public</span> : T <a class="code" href="classstd_1_1vector.html#aa4413180f775cf542ab040103fb94438">element</a>; }; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;};</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">class </span><a class="code" href="classActuatorAxis.html">ActuatorAxis</a>;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">//enum AxisOption;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">class </span><a class="code" href="classHardwareManager.html">HardwareManager</a>;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">class </span><a class="code" href="classStateManager.html">StateManager</a>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">class </span><a class="code" href="classExperiment.html">Experiment</a>;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">class </span><a class="code" href="classParms.html" title="A utility class to parse L-Studio like parameter files.">Parms</a>;</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div>
<div class="line"><a name="l00028"></a><span class="lineno"><a class="code" href="structRobotRecipeEntry.html">   28</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct </span>{</div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="code" href="structRobotRecipeEntry.html#a7cdf9542f5daaa1a4412cb2f3a32528e">   29</a></span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structRobotRecipeEntry.html#a7cdf9542f5daaa1a4412cb2f3a32528e">robotAxisID</a>;</div>
<div class="line"><a name="l00030"></a><span class="lineno"><a class="code" href="structRobotRecipeEntry.html#a8bcf17700439d64d12141e996d86f5c5">   30</a></span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structRobotRecipeEntry.html#a8bcf17700439d64d12141e996d86f5c5">actuatorSystemID</a>;</div>
<div class="line"><a name="l00031"></a><span class="lineno"><a class="code" href="structRobotRecipeEntry.html#a0843ab84a2da2c2f1a66a8ce44e11b8a">   31</a></span>&#160;    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structRobotRecipeEntry.html#a0843ab84a2da2c2f1a66a8ce44e11b8a">localAxisID</a>;</div>
<div class="line"><a name="l00032"></a><span class="lineno"><a class="code" href="structRobotRecipeEntry.html#ab3497f111ed9044ab7609d8c21b4916a">   32</a></span>&#160;    QString <a class="code" href="structRobotRecipeEntry.html#ab3497f111ed9044ab7609d8c21b4916a">name</a>;</div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="code" href="structRobotRecipeEntry.html#a0fb8982928814ac07289c5e3eb85ad6c">   33</a></span>&#160;    <span class="keywordtype">signed</span> <span class="keywordtype">int</span> <a class="code" href="structRobotRecipeEntry.html#a0fb8982928814ac07289c5e3eb85ad6c">flip</a>; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;} <a class="code" href="structRobotRecipeEntry.html">RobotRecipeEntry</a>;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;</div>
<div class="line"><a name="l00037"></a><span class="lineno"><a class="code" href="structRobotRecipe.html">   37</a></span>&#160;<span class="keyword">typedef</span> <span class="keyword">struct</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;{</div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="code" href="structRobotRecipe.html#ab170a020b17ca116a74a4b398d0a99db">   39</a></span>&#160;    <a class="code" href="classstd_1_1vector.html">std::vector&lt;RobotRecipeEntry&gt;</a> <a class="code" href="structRobotRecipe.html#ab170a020b17ca116a74a4b398d0a99db">entries</a>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;} <a class="code" href="structRobotRecipe.html" title="TODO: replace that with simply parameter file (robot recipe file)">RobotRecipe</a>;   </div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="code" href="classRobot.html">   42</a></span>&#160;<span class="keyword">class </span><a class="code" href="classRobot.html">Robot</a> {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <a class="code" href="classRobot.html#a59fbafc2b301235f5736ba09b603d783">Robot</a>(<a class="code" href="classExperiment.html">Experiment</a>&amp; experiment);    </div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classRobot.html#a924320124b09c2f2ac1621aa210d5f38">~Robot</a>();</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classRobot.html#addd6c688b1b4697dcfb7f59c5eb4d820" title="TODO: change RobotRecipe into a reference to par object.">BuildFromRecipe</a>(<a class="code" href="structRobotRecipe.html" title="TODO: replace that with simply parameter file (robot recipe file)">RobotRecipe</a> recipe);</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classRobot.html#a392ec2a33753ff38d7d7ed38674a6ec1" title="this time, int axis means the i-th axis in the robot collection, no relation to hardware id&#39;s...">Goto</a>(<span class="keywordtype">int</span> axis, <span class="keywordtype">double</span> positionMicrons); </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classRobot.html#a6028803bde72460dd961a3099dd32485">GetPosition</a>(<span class="keywordtype">int</span> axis, <span class="keywordtype">double</span>&amp; positionMicrons);</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classRobot.html#a6fcc15958db68e9ae90e940306c43f33" title="Sets axis option, returns false if option is unsupported or if axis is missing.">SetAxisOption</a>(<span class="keywordtype">int</span> axis, <a class="code" href="ActuatorAxis_8hpp.html#aa54708a5c8d0aae983e16b802396532b">AxisOption</a> option, <span class="keywordtype">double</span> value);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classRobot.html#ad41d6baac65d38790ca5810b7f14a17a" title="Call it if you want to update state of an axis selectively without updating other axes...">UpdateAxisState</a>(<span class="keywordtype">int</span> axis);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classRobot.html#a47cbe36ecea5e52540b77264bc9b14a1" title="Call it to update state for all axes.">UpdateRobotState</a>();</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classRobot.html#a94a9bab97c26b85eb3d65f5cb62d9aa4" title="Registers all fields to the StateManager.">RegisterFields</a>();</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classRobot.html#a62961cc17086e0b6a19b72ebf2409960">ParseRecipeFromIni</a>(<span class="keyword">const</span> <a class="code" href="classParms.html" title="A utility class to parse L-Studio like parameter files.">Parms</a>&amp; robotRecipePar, <a class="code" href="structRobotRecipe.html" title="TODO: replace that with simply parameter file (robot recipe file)">RobotRecipe</a>&amp; robotRecipe);    </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classRobot.html#a81113fbdb49a6a17c2601fbb4318d0f6">readParameters</a>(<span class="keyword">const</span> <a class="code" href="classParms.html" title="A utility class to parse L-Studio like parameter files.">Parms</a>&amp; parms);    </div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="code" href="classRobot.html#ac115f5f04d44b46899a4424ed2157080">   57</a></span>&#160;    <a class="code" href="classForceMeasurement.html">ForceMeasurement</a>&amp; <a class="code" href="classRobot.html#ac115f5f04d44b46899a4424ed2157080">forceMeasurement</a>()</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    {</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classRobot.html#a927240c8058a5bc527a81c6bd15a394a">_forceMeasurement</a>;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    }</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="code" href="classRobot.html#a401f61ae45e4c0587e9127e2c4c3dd67">   61</a></span>&#160;    <a class="code" href="classStateManager.html">StateManager</a>&amp; <a class="code" href="classRobot.html#a401f61ae45e4c0587e9127e2c4c3dd67">stateManager</a>()</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    {</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classRobot.html#ae14c5e0f4233f5f5340ee8f3664ac364">_stateManager</a>;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    }</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="code" href="classRobot.html#ac7b0162b6bb68b07d8b622c7aa4aff55">   66</a></span>&#160;    <a class="code" href="classHardwareManager.html">HardwareManager</a>&amp; <a class="code" href="classRobot.html#ac7b0162b6bb68b07d8b622c7aa4aff55">_hardwareManager</a>;</div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="code" href="classRobot.html#a4c8858bc161c836527fa919eae75c780">   67</a></span>&#160;    <a class="code" href="classstd_1_1vector.html">std::vector&lt;ActuatorAxis*&gt;</a> <a class="code" href="classRobot.html#a4c8858bc161c836527fa919eae75c780">_axes</a>;</div>
<div class="line"><a name="l00068"></a><span class="lineno"><a class="code" href="classRobot.html#ae14c5e0f4233f5f5340ee8f3664ac364">   68</a></span>&#160;    <a class="code" href="classStateManager.html">StateManager</a>&amp; <a class="code" href="classRobot.html#ae14c5e0f4233f5f5340ee8f3664ac364">_stateManager</a>;</div>
<div class="line"><a name="l00069"></a><span class="lineno"><a class="code" href="classRobot.html#a927240c8058a5bc527a81c6bd15a394a">   69</a></span>&#160;    <a class="code" href="classForceMeasurement.html">ForceMeasurement</a> <a class="code" href="classRobot.html#a927240c8058a5bc527a81c6bd15a394a">_forceMeasurement</a>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;};</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="preprocessor">#endif  </span><span class="comment">/* ROBOT_HPP */</span><span class="preprocessor"></span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Feb 26 2013 17:54:10 for morphorobotx by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1.2
</small></address>
</body>
</html>
